// Rafa Krajewski
// przykad zastosowania funkcji DeviceIoControl
// kod: IOCTL_DISK_GET_PARTITION_INFO_EX
#include <iostream>
#include <conio.h>
#include <windows.h>
#include <winioctl.h>

int main()
{
    PARTITION_INFORMATION_EX p;
    DWORD d;
    HANDLE h=CreateFile("\\\\.\\c:",FILE_ALL_ACCESS,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,0,NULL);
        if (h==INVALID_HANDLE_VALUE)
        {
        printf("Nie mona otworzyc urzadzenia!");
        return 0;
        }

    DeviceIoControl(h,IOCTL_DISK_GET_PARTITION_INFO_EX,NULL,0,&p,sizeof(p),&d,NULL);
    CloseHandle(h);
    printf("Offset partycji: %I64d bajtow\n",p.StartingOffset);
    printf("Rozmiar partycji: %I64d bajtow\n",p.PartitionLength);
    printf("Format partycji: ");
        if (p.PartitionStyle==PARTITION_STYLE_MBR)
        {
        printf("MBR\n");
            if (p.Mbr.BootIndicator==true) printf("Partycja rozruchowa: tak\n");
            else
            printf("Partycja rozruchowa: nie\n");
        printf("Ukryte sektory: %ld\n",p.Mbr.HiddenSectors);
        }
        if (p.PartitionStyle==PARTITION_STYLE_GPT)
        {
        printf("GPT\n");
        printf("Nazwa partycji: %s\n",p.Gpt.Name);
        }
        if (p.PartitionStyle==PARTITION_STYLE_RAW)
        printf("RAW\n");

    printf("Numer partycji: %d",p.PartitionNumber);
    getch();
	return 0;
}
