// Rafa Krajewski
// przykad zastosowania funkcji DeviceIoControl
// kod: IOCTL_DISK_GET_DRIVE_GEOMETRY_EX
#include <iostream>
#include <conio.h>
#include <windows.h>
#include <winioctl.h>

int main()
{
    DISK_GEOMETRY_EX p;
    DWORD d;
    // podajemy partycj, ale informacje wywietlane s o caym dysku na ktrym
    // jest partycja
    HANDLE h=CreateFile("\\\\.\\c:",FILE_ALL_ACCESS,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,0,NULL);
        if (h==INVALID_HANDLE_VALUE)
        {
        printf("Nie mozna otworzyc urzadzenia!");
        return 0;
        }

    DeviceIoControl(h,IOCTL_DISK_GET_DRIVE_GEOMETRY_EX,NULL,0,&p,sizeof(p),&d,NULL);
    printf("Rozmiar dysku: %I64d bajtow\n",p.DiskSize);
    printf("Cylindry: %I64d\n",p.Geometry.Cylinders);
    printf("Sciezek na cylinder: %ld\n",p.Geometry.TracksPerCylinder);
    printf("Sektorow na sciezk: %ld\n",p.Geometry.SectorsPerTrack);
    printf("Bajtow na sektor: %ld\n",p.Geometry.BytesPerSector);
    CloseHandle(h);
    getch();
	return 0;
}
